with Glib; use Glib;
with Gtk; use Gtk;
with Gdk.Types;       use Gdk.Types;
with Gtk.Widget;      use Gtk.Widget;
with Gtk.Enums;       use Gtk.Enums;
with Gtkada.Handlers; use Gtkada.Handlers;
with Callbacks_Gmast_Analysis; use Callbacks_Gmast_Analysis;
with Gmast_Analysis_Intl; use Gmast_Analysis_Intl;
with Annealing_Window_Pkg.Callbacks; use Annealing_Window_Pkg.Callbacks;

package body Annealing_Window_Pkg is

procedure Gtk_New (Annealing_Window : out Annealing_Window_Access) is
begin
   Annealing_Window := new Annealing_Window_Record;
   Annealing_Window_Pkg.Initialize (Annealing_Window);
end Gtk_New;

procedure Initialize (Annealing_Window : access Annealing_Window_Record'Class) is
   pragma Suppress (All_Checks);
begin
   Gtk.Window.Initialize (Annealing_Window, Window_Dialog);
   Set_Title (Annealing_Window, -"Annealing Parameters");
   Set_Policy (Annealing_Window, False, True, False);
   Set_Position (Annealing_Window, Win_Pos_None);
   Set_Modal (Annealing_Window, False);

   Gtk_New_Vbox (Annealing_Window.Vbox8, False, 0);
   Add (Annealing_Window, Annealing_Window.Vbox8);

   Gtk_New (Annealing_Window.Label14, -("Simulated Annealing Parameters"));
   Pack_Start (Annealing_Window.Vbox8, Annealing_Window.Label14, False, False, 5);
   Set_Alignment (Annealing_Window.Label14, 0.5, 0.5);
   Set_Padding (Annealing_Window.Label14, 0, 0);
   Set_Justify (Annealing_Window.Label14, Justify_Center);
   Set_Line_Wrap (Annealing_Window.Label14, False);

   Gtk_New (Annealing_Window.Frame2);
   Pack_Start (Annealing_Window.Vbox8, Annealing_Window.Frame2, True, True, 0);
   Set_Border_Width (Annealing_Window.Frame2, 15);
   Set_Shadow_Type (Annealing_Window.Frame2, Shadow_Etched_In);

   Gtk_New (Annealing_Window.Table3, 2, 2, False);
   Add (Annealing_Window.Frame2, Annealing_Window.Table3);
   Set_Row_Spacings (Annealing_Window.Table3, 0);
   Set_Col_Spacings (Annealing_Window.Table3, 0);

   Gtk_New (Annealing_Window.Entry_Max_Iterations);
   Attach (Annealing_Window.Table3, Annealing_Window.Entry_Max_Iterations, 1, 2, 0, 1,
     Expand or Fill, 0,
     0, 0);
   Set_Editable (Annealing_Window.Entry_Max_Iterations, True);
   Set_Max_Length (Annealing_Window.Entry_Max_Iterations, 0);
   Set_Text (Annealing_Window.Entry_Max_Iterations, -"");
   Set_Visibility (Annealing_Window.Entry_Max_Iterations, True);

   Gtk_New (Annealing_Window.Entry_Iterations_To_Op);
   Attach (Annealing_Window.Table3, Annealing_Window.Entry_Iterations_To_Op, 1, 2, 1, 2,
     Expand or Fill, 0,
     0, 0);
   Set_Editable (Annealing_Window.Entry_Iterations_To_Op, True);
   Set_Max_Length (Annealing_Window.Entry_Iterations_To_Op, 0);
   Set_Text (Annealing_Window.Entry_Iterations_To_Op, -"");
   Set_Visibility (Annealing_Window.Entry_Iterations_To_Op, True);

   Gtk_New (Annealing_Window.Label16, -("Optimization Iterations"));
   Attach (Annealing_Window.Table3, Annealing_Window.Label16, 0, 1, 1, 2,
     Expand, 0,
     0, 0);
   Set_Alignment (Annealing_Window.Label16, 0.5, 0.5);
   Set_Padding (Annealing_Window.Label16, 0, 0);
   Set_Justify (Annealing_Window.Label16, Justify_Center);
   Set_Line_Wrap (Annealing_Window.Label16, False);

   Gtk_New
     (Annealing_Window.Alignment5, 0.5, 0.5, 1.0, 
      1.0);
   Attach (Annealing_Window.Table3, Annealing_Window.Alignment5, 0, 1, 0, 1,
     Fill, Fill,
     0, 0);

   Gtk_New (Annealing_Window.Label15, -("Max Iterations"));
   Add (Annealing_Window.Alignment5, Annealing_Window.Label15);
   Set_Alignment (Annealing_Window.Label15, 1.0, 0.5);
   Set_Padding (Annealing_Window.Label15, 0, 0);
   Set_Justify (Annealing_Window.Label15, Justify_Right);
   Set_Line_Wrap (Annealing_Window.Label15, False);

   Gtk_New_Hbox (Annealing_Window.Hbox13, True, 0);
   Pack_Start (Annealing_Window.Vbox8, Annealing_Window.Hbox13, True, True, 0);
   Set_Border_Width (Annealing_Window.Hbox13, 14);

   Gtk_New (Annealing_Window.Set_Button, -"Set");
   Pack_Start (Annealing_Window.Hbox13, Annealing_Window.Set_Button, False, False, 0);
   Button_Callback.Connect
     (Annealing_Window.Set_Button, "clicked",
      Button_Callback.To_Marshaller (On_Set_Button_Clicked'Access));

   Gtk_New (Annealing_Window.Default_Button, -"Get Defaults");
   Pack_Start (Annealing_Window.Hbox13, Annealing_Window.Default_Button, False, False, 0);
   Button_Callback.Connect
     (Annealing_Window.Default_Button, "clicked",
      Button_Callback.To_Marshaller (On_Default_Button_Clicked'Access));

   Gtk_New (Annealing_Window.Ann_Help_Button, -"Help");
   Pack_Start (Annealing_Window.Hbox13, Annealing_Window.Ann_Help_Button, False, False, 0);
   Button_Callback.Connect
     (Annealing_Window.Ann_Help_Button, "clicked",
      Button_Callback.To_Marshaller (On_Ann_Help_Button_Clicked'Access));

   Gtk_New (Annealing_Window.Cancel_Button, -"Cancel");
   Pack_Start (Annealing_Window.Hbox13, Annealing_Window.Cancel_Button, False, False, 0);
   Button_Callback.Connect
     (Annealing_Window.Cancel_Button, "clicked",
      Button_Callback.To_Marshaller (On_Cancel_Button_Clicked'Access));

end Initialize;

end Annealing_Window_Pkg;
