with Glib; use Glib;
with Gtk; use Gtk;
with Gdk.Types;       use Gdk.Types;
with Gtk.Widget;      use Gtk.Widget;
with Gtk.Enums;       use Gtk.Enums;
with Gtkada.Handlers; use Gtkada.Handlers;
with Callbacks_Gmast_Analysis; use Callbacks_Gmast_Analysis;
with Gmast_Analysis_Intl; use Gmast_Analysis_Intl;
with Hopa_Window_Pkg.Callbacks; use Hopa_Window_Pkg.Callbacks;

package body Hopa_Window_Pkg is

procedure Gtk_New (Hopa_Window : out Hopa_Window_Access) is
begin
   Hopa_Window := new Hopa_Window_Record;
   Hopa_Window_Pkg.Initialize (Hopa_Window);
end Gtk_New;

procedure Initialize (Hopa_Window : access Hopa_Window_Record'Class) is
   pragma Suppress (All_Checks);
begin
   Gtk.Window.Initialize (Hopa_Window, Window_Dialog);
   Set_Title (Hopa_Window, -"HOPA Parameters");
   Set_Policy (Hopa_Window, False, True, True);
   Set_Position (Hopa_Window, Win_Pos_Mouse);
   Set_Modal (Hopa_Window, True);

   Gtk_New_Vbox (Hopa_Window.Vbox9, False, 0);
   Add (Hopa_Window, Hopa_Window.Vbox9);

   Gtk_New (Hopa_Window.Label27, -("HOPA Parameters"));
   Pack_Start (Hopa_Window.Vbox9, Hopa_Window.Label27, True, True, 5);
   Set_Alignment (Hopa_Window.Label27, 0.5, 0.5);
   Set_Padding (Hopa_Window.Label27, 0, 0);
   Set_Justify (Hopa_Window.Label27, Justify_Center);
   Set_Line_Wrap (Hopa_Window.Label27, False);

   Gtk_New (Hopa_Window.Frame3);
   Pack_Start (Hopa_Window.Vbox9, Hopa_Window.Frame3, True, True, 0);
   Set_Border_Width (Hopa_Window.Frame3, 15);
   Set_Shadow_Type (Hopa_Window.Frame3, Shadow_Etched_In);

   Gtk_New (Hopa_Window.Table4, 4, 2, False);
   Add (Hopa_Window.Frame3, Hopa_Window.Table4);
   Set_Row_Spacings (Hopa_Window.Table4, 0);
   Set_Col_Spacings (Hopa_Window.Table4, 0);

   Gtk_New (Hopa_Window.Ka_Entry);
   Attach (Hopa_Window.Table4, Hopa_Window.Ka_Entry, 1, 2, 0, 1,
     Expand or Fill, 0,
     0, 0);
   Set_Editable (Hopa_Window.Ka_Entry, True);
   Set_Max_Length (Hopa_Window.Ka_Entry, 0);
   Set_Text (Hopa_Window.Ka_Entry, -"");
   Set_Visibility (Hopa_Window.Ka_Entry, True);

   Gtk_New (Hopa_Window.Kr_Entry);
   Attach (Hopa_Window.Table4, Hopa_Window.Kr_Entry, 1, 2, 1, 2,
     Expand or Fill, 0,
     0, 0);
   Set_Editable (Hopa_Window.Kr_Entry, True);
   Set_Max_Length (Hopa_Window.Kr_Entry, 0);
   Set_Text (Hopa_Window.Kr_Entry, -"");
   Set_Visibility (Hopa_Window.Kr_Entry, True);

   Gtk_New
     (Hopa_Window.Alignment6, 1.0, 0.5, 1.0, 
      1.0);
   Attach (Hopa_Window.Table4, Hopa_Window.Alignment6, 0, 1, 0, 1,
     Fill, Fill,
     0, 0);

   Gtk_New
     (Hopa_Window.Alignment10, 1.0, 0.5, 1.0, 
      1.0);
   Add (Hopa_Window.Alignment6, Hopa_Window.Alignment10);

   Gtk_New (Hopa_Window.Label30, -("Ka List"));
   Add (Hopa_Window.Alignment10, Hopa_Window.Label30);
   Set_Alignment (Hopa_Window.Label30, 1.0, 0.5);
   Set_Padding (Hopa_Window.Label30, 5, 0);
   Set_Justify (Hopa_Window.Label30, Justify_Right);
   Set_Line_Wrap (Hopa_Window.Label30, False);

   Gtk_New
     (Hopa_Window.Alignment7, 1.0, 0.5, 0.95, 
      0.95);
   Attach (Hopa_Window.Table4, Hopa_Window.Alignment7, 0, 1, 3, 4,
     Fill, Expand or Fill,
     0, 0);

   Gtk_New (Hopa_Window.Label20, -("Optimization Iterations"));
   Add (Hopa_Window.Alignment7, Hopa_Window.Label20);
   Set_Alignment (Hopa_Window.Label20, 1.0, 0.5);
   Set_Padding (Hopa_Window.Label20, 5, 0);
   Set_Justify (Hopa_Window.Label20, Justify_Right);
   Set_Line_Wrap (Hopa_Window.Label20, False);

   Gtk_New (Hopa_Window.Opiter_Entry);
   Attach (Hopa_Window.Table4, Hopa_Window.Opiter_Entry, 1, 2, 3, 4,
     Expand or Fill, 0,
     0, 0);
   Set_Editable (Hopa_Window.Opiter_Entry, True);
   Set_Max_Length (Hopa_Window.Opiter_Entry, 0);
   Set_Text (Hopa_Window.Opiter_Entry, -"");
   Set_Visibility (Hopa_Window.Opiter_Entry, True);

   Gtk_New
     (Hopa_Window.Alignment8, 1.0, 0.5, 0.95, 
      0.95);
   Attach (Hopa_Window.Table4, Hopa_Window.Alignment8, 0, 1, 2, 3,
     Fill, Expand or Fill,
     0, 0);

   Gtk_New (Hopa_Window.Label28, -("Iterations List"));
   Add (Hopa_Window.Alignment8, Hopa_Window.Label28);
   Set_Alignment (Hopa_Window.Label28, 1.0, 0.5);
   Set_Padding (Hopa_Window.Label28, 5, 0);
   Set_Justify (Hopa_Window.Label28, Justify_Right);
   Set_Line_Wrap (Hopa_Window.Label28, False);

   Gtk_New
     (Hopa_Window.Alignment9, 1.0, 0.5, 0.95, 
      0.95);
   Attach (Hopa_Window.Table4, Hopa_Window.Alignment9, 0, 1, 1, 2,
     Fill, Fill,
     0, 0);

   Gtk_New (Hopa_Window.Label29, -("Kr List"));
   Add (Hopa_Window.Alignment9, Hopa_Window.Label29);
   Set_Alignment (Hopa_Window.Label29, 1.0, 0.5);
   Set_Padding (Hopa_Window.Label29, 5, 0);
   Set_Justify (Hopa_Window.Label29, Justify_Right);
   Set_Line_Wrap (Hopa_Window.Label29, False);

   Gtk_New (Hopa_Window.Iter_List_Entry);
   Attach (Hopa_Window.Table4, Hopa_Window.Iter_List_Entry, 1, 2, 2, 3,
     Expand or Fill, 0,
     0, 0);
   Set_Editable (Hopa_Window.Iter_List_Entry, True);
   Set_Max_Length (Hopa_Window.Iter_List_Entry, 0);
   Set_Text (Hopa_Window.Iter_List_Entry, -"");
   Set_Visibility (Hopa_Window.Iter_List_Entry, True);

   Gtk_New_Hbox (Hopa_Window.Hbox14, True, 0);
   Pack_Start (Hopa_Window.Vbox9, Hopa_Window.Hbox14, True, True, 0);
   Set_Border_Width (Hopa_Window.Hbox14, 14);

   Gtk_New (Hopa_Window.Hset_Button, -"Set");
   Pack_Start (Hopa_Window.Hbox14, Hopa_Window.Hset_Button, False, False, 0);
   Button_Callback.Connect
     (Hopa_Window.Hset_Button, "clicked",
      Button_Callback.To_Marshaller (On_Hset_Button_Clicked'Access));

   Gtk_New (Hopa_Window.Hget_Defaults_Button, -"Get Defaults");
   Pack_Start (Hopa_Window.Hbox14, Hopa_Window.Hget_Defaults_Button, False, False, 0);
   Button_Callback.Connect
     (Hopa_Window.Hget_Defaults_Button, "clicked",
      Button_Callback.To_Marshaller (On_Hget_Defaults_Button_Clicked'Access));

   Gtk_New (Hopa_Window.Hopa_Help_Button, -"Help");
   Pack_Start (Hopa_Window.Hbox14, Hopa_Window.Hopa_Help_Button, False, False, 0);
   Button_Callback.Connect
     (Hopa_Window.Hopa_Help_Button, "clicked",
      Button_Callback.To_Marshaller (On_Hopa_Help_Button_Clicked'Access));

   Gtk_New (Hopa_Window.Hcancel_Button, -"Cancel");
   Pack_Start (Hopa_Window.Hbox14, Hopa_Window.Hcancel_Button, False, False, 0);
   Button_Callback.Connect
     (Hopa_Window.Hcancel_Button, "clicked",
      Button_Callback.To_Marshaller (On_Hcancel_Button_Clicked'Access));

end Initialize;

end Hopa_Window_Pkg;
