with Mast.IO,Mast.Scheduling_Servers,Mast.Operations,Var_Strings;
use Var_Strings;
use type Mast.Scheduling_Servers.Scheduling_Server_Ref;
use type Mast.Operations.Simple_Operation_Ref;
package body Mast.Drivers is

   -----------
   -- Clone --
   -----------

   function Clone
     (The_List : in Lists.List)
     return Lists.List
   is
      The_Copy : Lists.List;
      Iterator : Lists.Iteration_Object;
      Drv_Ref, Drv_Ref_Copy : Driver_Ref;
   begin
      Lists.Rewind(The_List,Iterator);
      for I in 1..Lists.Size(The_List) loop
         Lists.Get_Next_Item(Drv_Ref,The_List,Iterator);
         Drv_Ref_Copy:=Clone(Drv_Ref.all);
         Lists.Add(Drv_Ref_Copy,The_Copy);
      end loop;
      return The_Copy;
   end Clone;

   -----------
   -- Clone --
   -----------

   function Clone
     (Drv : Packet_Driver)
     return  Driver_Ref
   is
     Drv_Ref : Driver_Ref;
   begin
      Drv_Ref:=new Packet_Driver;
      if Drv.Packet_Server/=null then
         Packet_Driver(Drv_Ref.all).Packet_Server:=
           Scheduling_Servers.Clone(Drv.Packet_Server.all);
      end if;
      if Drv.Packet_Send_Operation/=null then
         Packet_Driver(Drv_Ref.all).Packet_Send_Operation:=
           Operations.Simple_Operation_Ref
           (Operations.Clone(Drv.Packet_Send_Operation.all));
      end if;
      if Drv.Packet_Receive_Operation/=null then
         Packet_Driver(Drv_Ref.all).Packet_Receive_Operation:=
           Operations.Simple_Operation_Ref
           (Operations.Clone(Drv.Packet_Receive_Operation.all));
      end if;
      return Drv_Ref;
   end Clone;

   -----------
   -- Clone --
   -----------

   function Clone
     (Drv : Character_Packet_Driver)
     return  Driver_Ref
   is
     Drv_Ref : Driver_Ref;
   begin
      Drv_Ref:=new Character_Packet_Driver;
      if Drv.Packet_Server/=null then
         Character_Packet_Driver(Drv_Ref.all).Packet_Server:=
           Scheduling_Servers.Clone(Drv.Packet_Server.all);
      end if;
      if Drv.Character_Server/=null then
         Character_Packet_Driver(Drv_Ref.all).Character_Server:=
           Scheduling_Servers.Clone(Drv.Character_Server.all);
      end if;
      if Drv.Packet_Send_Operation/=null then
         Character_Packet_Driver(Drv_Ref.all).Packet_Send_Operation:=
           Operations.Simple_Operation_Ref
           (Operations.Clone(Drv.Packet_Send_Operation.all));
      end if;
      if Drv.Packet_Receive_Operation/=null then
         Character_Packet_Driver(Drv_Ref.all).Packet_Receive_Operation:=
           Operations.Simple_Operation_Ref
           (Operations.Clone(Drv.Packet_Receive_Operation.all));
      end if;
      if Drv.Character_Send_Operation/=null then
         Character_Packet_Driver(Drv_Ref.all).Character_Send_Operation:=
           Operations.Simple_Operation_Ref
           (Operations.Clone(Drv.Character_Send_Operation.all));
      end if;
      if Drv.Character_Receive_Operation/=null then
         Character_Packet_Driver(Drv_Ref.all).Character_Receive_Operation:=
           Operations.Simple_Operation_Ref
           (Operations.Clone(Drv.Character_Receive_Operation.all));
      end if;
      Character_Packet_Driver(Drv_Ref.all).Character_Transmission_Time:=
        Drv.Character_Transmission_Time;
      return Drv_Ref;
   end Clone;

   ---------------------------------
   -- Character_Receive_Operation --
   ---------------------------------

   function Character_Receive_Operation
     (The_Driver : Character_Packet_Driver)
      return Operations.Simple_Operation_Ref
   is
   begin
      return The_Driver.Character_Receive_Operation;
   end Character_Receive_Operation;

   ------------------------------
   -- Character_Send_Operation --
   ------------------------------

   function Character_Send_Operation
     (The_Driver : Character_Packet_Driver)
      return Operations.Simple_Operation_Ref
   is
   begin
      return The_Driver.Character_Send_Operation;
   end Character_Send_Operation;

   ---------------------------------
   -- Character_Transmission_Time --
   ---------------------------------

   function Character_Transmission_Time
     (The_Driver : Character_Packet_Driver)
     return Time
   is
   begin
      return The_Driver.Character_Transmission_Time;
   end Character_Transmission_Time;

   ----------------------
   -- Character_Server --
   ----------------------

   function Character_Server
     (The_Driver : Character_Packet_Driver)
      return Scheduling_Servers.Scheduling_Server_Ref
   is
   begin
      return The_Driver.Character_Server;
   end Character_Server;

   -------------------
   -- Packet_Server --
   -------------------

   function Packet_Server
     (The_Driver : Packet_Driver)
      return Scheduling_Servers.Scheduling_Server_Ref
   is
   begin
      return The_Driver.Packet_Server;
   end Packet_Server;

   ------------------------------
   -- Packet_Receive_Operation --
   ------------------------------

   function Packet_Receive_Operation
     (The_Driver : Packet_Driver)
      return Operations.Simple_Operation_Ref
   is
   begin
      return The_Driver.Packet_Receive_Operation;
   end Packet_Receive_Operation;

   ---------------------------
   -- Packet_Send_Operation --
   ---------------------------

   function Packet_Send_Operation
     (The_Driver : Packet_Driver)
      return Operations.Simple_Operation_Ref
   is
   begin
      return The_Driver.Packet_Send_Operation;
   end Packet_Send_Operation;

   -----------
   -- Print --
   -----------

   procedure Print
     (File : Ada.Text_IO.File_Type;
      Drv : in out Driver;
      Indentation : Positive;
      Finalize    : Boolean:=False)
   is
   begin
      Ada.Text_IO.Set_Col(File,Ada.Text_IO.Count(Indentation));
      Ada.Text_IO.Put(File,"(");
   end Print;

   -----------
   -- Print --
   -----------

   procedure Print
     (File : Ada.Text_IO.File_Type;
      The_List : in out Lists.List;
      Indentation : Positive)
   is
      Drv_Ref : Driver_Ref;
      Iterator : Lists.Index;
   begin
      MAST.IO.Print_List_Item(File,MAST.IO.Left_Paren,
                              Indentation);
      Lists.Rewind(The_List,Iterator);
      for I in 1..Lists.Size(The_List) loop
         Lists.Get_Next_Item(Drv_Ref,The_List,Iterator);
         Print(File,Drv_Ref.all,Indentation+1,True);
         if I=Lists.Size(The_List) then
            Ada.Text_IO.Put(File,")");
         else
            MAST.IO.Print_Separator(File);
         end if;
      end loop;
   end Print;

   -----------
   -- Print --
   -----------

   procedure Print
     (File : Ada.Text_IO.File_Type;
      Drv : in out Packet_Driver;
      Indentation : Positive;
      Finalize    : Boolean:=False)
   is
      Names_Length : constant Positive := 24;
   begin
      Print(File,Driver(Drv),Indentation);
      MAST.IO.Print_Arg
        (File,"Type",
         "Packet_Driver",Indentation+2,Names_Length);
      if Drv.Packet_Server/=null then
         MAST.IO.Print_Separator(File);
         MAST.IO.Print_Arg
           (File,"Packet_Server","",
            Indentation+2,Names_Length);
         Scheduling_Servers.Print
           (File,Drv.Packet_Server.all,Indentation+5,False,False);
      end if;
      if Drv.Packet_Send_Operation/=null then
         MAST.IO.Print_Separator(File);
         MAST.IO.Print_Arg
           (File,"Packet_Send_Operation","",
            Indentation+2,Names_Length);
         Operations.Print
           (File,Drv.Packet_Send_Operation.all,Indentation+5,False,False);
      end if;
      if Drv.Packet_Receive_Operation/=null then
         MAST.IO.Print_Separator(File);
         MAST.IO.Print_Arg
           (File,"Packet_Receive_Operation","",
            Indentation+2,Names_Length);
         Operations.Print
           (File,Drv.Packet_Receive_Operation.all,Indentation+5,False,False);
      end if;
      Ada.Text_IO.Put(File,")");
   end Print;

   -----------
   -- Print --
   -----------

   procedure Print
     (File : Ada.Text_IO.File_Type;
      Drv : in out Character_Packet_Driver;
      Indentation : Positive;
      Finalize    : Boolean:=False)
   is
      Names_Length : constant Positive := 27;
   begin
      Print(File,Driver(Drv),Indentation);
      MAST.IO.Print_Arg
        (File,"Type",
         "Character_Packet_Driver",Indentation+2,Names_Length);
      if Drv.Packet_Server/=null then
         MAST.IO.Print_Separator(File);
         MAST.IO.Print_Arg
           (File,"Packet_Server","",
            Indentation+2,Names_Length);
         Scheduling_Servers.Print
           (File,Drv.Packet_Server.all,Indentation+5,False,False);
      end if;
      if Drv.Packet_Send_Operation/=null then
         MAST.IO.Print_Separator(File);
         MAST.IO.Print_Arg
           (File,"Packet_Send_Operation","",
            Indentation+2,Names_Length);
         Operations.Print
           (File,Drv.Packet_Send_Operation.all,Indentation+5,False,False);
      end if;
      if Drv.Packet_Receive_Operation/=null then
         MAST.IO.Print_Separator(File);
         MAST.IO.Print_Arg
           (File,"Packet_Receive_Operation","",
            Indentation+2,Names_Length);
         Operations.Print
           (File,Drv.Packet_Receive_Operation.all,Indentation+5,False,False);
      end if;
      if Drv.Character_Server/=null then
         MAST.IO.Print_Separator(File);
         MAST.IO.Print_Arg
           (File,"Character_Server","",
            Indentation+2,Names_Length);
         Scheduling_Servers.Print
           (File,Drv.Character_Server.all,Indentation+5,False,False);
      end if;
      if Drv.Character_Send_Operation/=null then
         MAST.IO.Print_Separator(File);
         MAST.IO.Print_Arg
           (File,"Character_Send_Operation","",
            Indentation+2,Names_Length);
         Operations.Print
           (File,Drv.Character_Send_Operation.all,
            Indentation+5,False,False);
      end if;
      if Drv.Character_Receive_Operation/=null then
         MAST.IO.Print_Separator(File);
         MAST.IO.Print_Arg
           (File,"Character_Receive_Operation","",
            Indentation+2,Names_Length);
         Operations.Print
           (File,Drv.Character_Receive_Operation.all,
            Indentation+5,False,False);
      end if;
      MAST.IO.Print_Separator(File);
      MAST.IO.Print_Arg
        (File,"Character_Transmission_Time",
         IO.Time_Image(Drv.Character_Transmission_Time),
         Indentation+2,Names_Length);
      Ada.Text_IO.Put(File,")");
   end Print;

   -------------------------------------
   -- Set_Character_Receive_Operation --
   -------------------------------------

   procedure Set_Character_Receive_Operation
     (The_Driver : in out Character_Packet_Driver;
      The_Character_Receive_Operation : Operations.Simple_Operation_Ref)
   is
   begin
      The_Driver.Character_Receive_Operation:=
        The_Character_Receive_Operation;
   end Set_Character_Receive_Operation;

   ----------------------------------
   -- Set_Character_Send_Operation --
   ----------------------------------

   procedure Set_Character_Send_Operation
     (The_Driver : in out Character_Packet_Driver;
      The_Character_Send_Operation : Operations.Simple_Operation_Ref)
   is
   begin
      The_Driver.Character_Send_Operation:=
        The_Character_send_Operation;
   end Set_Character_Send_Operation;

   --------------------------
   -- Set_Character_Server --
   --------------------------

   procedure Set_Character_Server
     (The_Driver : in out Character_Packet_Driver;
      The_Character_Server : Scheduling_Servers.Scheduling_Server_Ref)
   is
   begin
      The_Driver.Character_Server:=The_Character_Server;
   end Set_Character_Server;

   -----------------------
   -- Set_Packet_Server --
   -----------------------

   procedure Set_Packet_Server
     (The_Driver : in out Packet_Driver;
      The_Packet_Server : Scheduling_Servers.Scheduling_Server_Ref)
   is
   begin
      The_Driver.Packet_Server:=The_Packet_Server;
   end Set_Packet_Server;

   ----------------------------------
   -- Set_Packet_Receive_Operation --
   ----------------------------------

   procedure Set_Packet_Receive_Operation
     (The_Driver : in out Packet_Driver;
      The_Packet_Receive_Operation : Operations.Simple_Operation_Ref)
   is
   begin
      The_Driver.Packet_Receive_Operation:=The_Packet_Receive_Operation;
   end Set_Packet_Receive_Operation;

   -------------------------------
   -- Set_Packet_Send_Operation --
   -------------------------------

   procedure Set_Packet_Send_Operation
     (The_Driver : in out Packet_Driver;
      The_Packet_Send_Operation : Operations.Simple_Operation_Ref)
   is
   begin
      The_Driver.Packet_Send_Operation:=The_Packet_Send_Operation;
   end Set_Packet_Send_Operation;

   -------------------------------------
   -- Set_Character_Transmission_Time --
   -------------------------------------

   procedure Set_Character_Transmission_Time
     (The_Driver : in out Character_Packet_Driver;
      The_Transmission_Time : Time)
   is
   begin
      The_Driver.Character_Transmission_Time:=The_Transmission_Time;
   end Set_Character_Transmission_Time;

end Mast.Drivers;

