-----------------------------------------------------------------------
--                              Mast                                 --
--     Modelling and Analysis Suite for Real-Time Applications       --
--                                                                   --
--                       Copyright (C) 2000                          --
--                 Universidad de Cantabria, SPAIN                   --
--                                                                   --
-- Authors: Michael Gonzalez       mgh@ctr.unican.es                 --
--          Jose Javier Gutierrez  gutierjj@ctr.unican.es            --
--          Jose Carlos Palencia   palencij@ctr.unican.es            --
--          Jose Maria Drake       drakej@ctr.unican.es              --
--                                                                   --
-- This program is free software; you can redistribute it and/or     --
-- modify it under the terms of the GNU General Public               --
-- License as published by the Free Software Foundation; either      --
-- version 2 of the License, or (at your option) any later version.  --
--                                                                   --
-- This program is distributed in the hope that it will be useful,   --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of    --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU --
-- General Public License for more details.                          --
--                                                                   --
-- You should have received a copy of the GNU General Public         --
-- License along with this program; if not, write to the             --
-- Free Software Foundation, Inc., 59 Temple Place - Suite 330,      --
-- Boston, MA 02111-1307, USA.                                       --
--                                                                   --
-----------------------------------------------------------------------

with Hash_Lists;

package Mast.Transactions.Results is

   type Results_List is private;

   procedure Set_Slack
     (Trans_Ref : Transaction_Ref;
      Slack : Float;
      The_List : in out Results_List);

   function Slack_Of
     (Trans_Ref : Transaction_Ref;
      The_List : Results_List) return Float;

   procedure Print
     (File : Ada.Text_IO.File_Type;
      The_List : in out Results_List;
      Indentation : Positive:=1;
      Finalize    : Boolean:=False);

private

   type Transaction_Result is record
      Slack : Float;
   end record;

   package Results_Lists is new Hash_Lists
     (Transaction_Ref,Transaction_Result,"=");

   type Results_List is new Results_Lists.List;

end Mast.Transactions.Results;
