-----------------------------------------------------------------------
--                              Mast                                 --
--     Modelling and Analysis Suite for Real-Time Applications       --
--                                                                   --
--                       Copyright (C) 2000                          --
--                 Universidad de Cantabria, SPAIN                   --
--                                                                   --
-- Authors: Michael Gonzalez       mgh@ctr.unican.es                 --
--          Jose Javier Gutierrez  gutierjj@ctr.unican.es            --
--          Jose Carlos Palencia   palencij@ctr.unican.es            --
--          Jose Maria Drake       drakej@ctr.unican.es              --
--                                                                   --
-- This program is free software; you can redistribute it and/or     --
-- modify it under the terms of the GNU General Public               --
-- License as published by the Free Software Foundation; either      --
-- version 2 of the License, or (at your option) any later version.  --
--                                                                   --
-- This program is distributed in the hope that it will be useful,   --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of    --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU --
-- General Public License for more details.                          --
--                                                                   --
-- You should have received a copy of the GNU General Public         --
-- License along with this program; if not, write to the             --
-- Free Software Foundation, Inc., 59 Temple Place - Suite 330,      --
-- Boston, MA 02111-1307, USA.                                       --
--                                                                   --
-----------------------------------------------------------------------

package body Mast is

   ---------
   -- "*" --
   ---------

   function "*"
     (T : Time;
      S : Processor_Speed)
      return Normalized_Execution_Time
   is
   begin
      return Normalized_Execution_Time(T)*Normalized_Execution_Time(S);
   end "*";

   ---------
   -- "/" --
   ---------

   function "/"
     (E : Normalized_Execution_Time;
      S : Processor_Speed)
      return Time
   is
   begin
      return Time(E)/Time(S);
   end "/";

   ---------
   -- "+" --
   ---------

   function "+"
     (Abs_Time : Absolute_Time;
      Interval : Time_Interval)
      return Absolute_Time
   is
   begin
      return Abs_Time+Absolute_Time(Interval);
   end "+";

   ---------
   -- "+" --
   ---------

   function "+"
     (Interval : Time_Interval;
      Abs_Time : Absolute_Time)
      return Absolute_Time
   is
   begin
      return Abs_Time+Absolute_Time(Interval);
   end "+";

   ---------
   -- "-" --
   ---------

   function "-"
     (Abs_Time : Absolute_Time;
      Interval : Time_Interval)
      return Absolute_Time
   is
   begin
      return Abs_Time-Absolute_Time(Interval);
   end "-";

   ---------
   -- "-" --
   ---------

   function "-"
     (Abs_Time1,Abs_Time2 : Absolute_Time)
      return Time_Interval
   is
   begin
      return Time_Interval(Abs_Time1)-Time_Interval(Abs_Time2);
   end "-";

end Mast;

